--Consumer-producer example
--The property is that a consumer can consume a resource only when one is 
--available

--variable definition
var
  initc, whilec, whileget, waitget, competec, notifyc, consume, endc, initp, whilep, whileput, waitput, competep, notifyp, produce, returnp, available, notavailable, lock, notlock : discrete;

automaton P

synclabs : ;

initially LOC & True;


loc LOC : while initc >= 0 & whilec >= 0 & whileget >= 0 & waitget >= 0 & competec >= 0 & notifyc >= 0 & consume >= 0 & endc >= 0 & initp >= 0 & whilep >= 0 & whileput >= 0 & waitput >= 0 & competep >= 0 & notifyp >= 0 & produce >= 0 & returnp >= 0 & available >= 0 & notavailable >= 0 & lock >= 0 & notlock >= 0
		wait {}

--consumer

	when
		initc >= 1 
	do {
	initc' = initc - 1,
	whilec' = whilec + 1 } goto LOC;

	when
		whilec >= 1 & notlock >= 1 
	do {
	whilec' = whilec - 1,
	whileget' = whileget + 1,
	notlock' = notlock - 1,
	lock' = lock + 1 } goto LOC;

	when
		whileget >= 1 & notavailable >= 1 & lock >= 1 
	do {
	whileget' = whileget - 1,
	waitget' = waitget + 1,
	lock' = lock - 1,
	notlock' = notlock + 1 } goto LOC;

	when
		competec >= 1 & notlock >= 1 
	do {
	competec' = competec - 1,
	whileget' = whileget + 1,
	notlock' = notlock - 1,
	lock' = lock + 1 } goto LOC;


	when
		whileget >= 1 & available >= 1 
	do {
	whileget' = whileget - 1,
	consume' = consume + 1 } goto LOC;


	when
		consume >= 1 
	do {	
        consume' = consume - 1,
	notifyc' = notifyc + 1,
	notavailable' = notavailable + 1,
	available' = available - 1 } goto LOC;


	when	
		notifyc >= 1 
	do {
	notifyc' = notifyc - 1,
	endc' = endc + 1,
	competec' = competec + waitget,
	waitget' = 0,
	competep' = competep + waitput,
	waitput' = 0 } goto LOC;


	when
		endc >= 1 & lock >= 1 
	do {
	endc' = endc - 1,
	whilec' = whilec + 1,
	lock' = lock - 1,
	notlock' = notlock + 1 } goto LOC;

--producer


	when
		initp >= 1 
	do {
	initp' =initp - 1,
	whilep' = whilep + 1 } goto LOC;


	when
		whilep >= 1 & notlock >= 1 
	do {
	whilep' = whilep - 1,
	whileput' = whileput + 1,
	notlock' = notlock - 1,
	lock' = lock + 1 } goto LOC;


	when
		whileput >= 1 & lock >= 1 & available >= 1 
	do {
	whileput' = whileput - 1,
	waitput' = waitput + 1,
	lock' = lock - 1,
	notlock' = notlock + 1} goto LOC;
	


	when
		competep >= 1 & notlock >= 1 
	do {
	competep' = competep - 1,
	whileput' = whileput + 1,
	notlock' = notlock - 1,
	lock' = lock + 1 } goto LOC;
	

	when
		whileput >= 1 & notavailable >= 1 
	do {
	whileput' = whileput - 1,
	produce' = produce + 1 } goto LOC;


	when
		produce >= 1 
	do {
	produce' = produce - 1,
	notifyp' = notifyp + 1,
	available' = available + 1,
	notavailable' = notavailable - 1} goto LOC;


	when
		notifyp >= 1 
	do {
	notifyp' = notifyp - 1,
	returnp' = returnp + 1,
	competec' = competec + waitget,
	waitget' = 0,
	competep' = competep + waitput,
	waitput' = 0 } goto LOC;

	when
		returnp >= 1 & lock >= 1 
	do {
	returnp' = returnp - 1,
	whilep' = whilep + 1,
	lock' = lock - 1,
	notlock' = notlock + 1 } goto LOC;
end

var
	init_reg,final_reg, reached : region;

init_reg := initc >= 1 & initp >= 1 & whilec = 0 & whileget = 0 & waitget = 0 & competec = 0 & notifyc = 0 & consume = 0 & endc = 0 & whilep = 0 & whileput = 0 & waitput = 0 & competep = 0 & notifyp = 0 & produce = 0 & returnp = 0 & available =0 & notavailable = 1 & lock = 0 & notlock = 1;

final_reg :=  produce >= 1 & available >= 1;

reached := reach backward from final_reg endreach;

if empty(reached & init_reg) then
	prints "SAFETY HOLDS!";
else
	prints "SAFETY DOES NOT HOLD!";
endif;
